;;; ClojureCubes --- The Clojure cubes for FG42 -*- lexical-binding: t; -*-
;;
;; Copyright (c) 2010-2021 Sameer Rahmani & Contributors
;;
;; Author: Pouya Abbassi <abbassi.pouya@gmail.com>
;; URL: https://gitlab.com/FG42/FG42
;; Version: 3.0.0
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;; Commentary:
;;; Code:
(require 'fpkg)
(require 'fg42/cube)
(require 'fg42/utils)

;(autoload-cube 'fg42/initialize-golang "golang/core.el" "Initalize the go mode.")


(defun my-clojure-hook ()
  (paredit-mode 1)
  (aggressive-indent-mode 1)
  (rainbow-delimiters-mode 1))

(defcube fg42/clojure-cube
  "Clojure support cube for fg42."
  (:title "Clojure cube"
          :flag clojure
          :flag-default t)

  (fpkg/use aggressive-indent-mode
    :config (paredit-mode +1))

  (fpkg/use rainbow-delimiters
    :config (rainbow-delimiters-mode +1))

  (fpkg/use cider)

  (fpkg/use clojure-mode
    :hook (clojure-mode . my-clojure-hook)
    :config
    (progn
      (when-flag lsp
        (add-hook 'clojure-mode-hook
                  (lambda ()
                    (when (not (boundp 'lsp))
                      (require 'lsp)
                      (lsp-deferred))))))))

(provide 'cubes/clojure)
;;; clojure.el ends here
